import fs from 'fs';
import path from 'path';
import { resolveTilde } from './util';

export default class Repository {

  base_path: string;
  ingest_path: string;
  archive_path: string;
  output_path: string;

  constructor(base_path: string) {
    // set base path
    this.base_path = resolveTilde(base_path);

    // set sub-directory paths
    this.ingest_path = path.join(this.base_path, 'ingest');
    this.archive_path = path.join(this.base_path, 'archive');
    this.output_path = path.join(this.base_path, 'output');
  }
  
  initialize(): void {
    console.log(`Initializing video repository at ${this.base_path}.`);

    // ensure each directory exists
    if (!fs.existsSync(this.base_path)) {
      fs.mkdirSync(this.base_path);
    }
    if (!fs.existsSync(this.ingest_path)) {
      fs.mkdirSync(this.ingest_path);
    }
    if (!fs.existsSync(this.archive_path)) {
      fs.mkdirSync(this.archive_path);
    }
    if (!fs.existsSync(this.output_path)) {
      fs.mkdirSync(this.output_path);
    }
  }

}
